<?php
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 

global $template;

function get_files($dir)
{
 $returned=array();
 if (is_dir($dir)) 
 {
      if ($dh = opendir($dir)) 
      {
        while (($file = readdir($dh)) !== false) 
        {
          if(!(($file=='.')||($file=='..')))
          {
            if(is_dir($dir."/".$file))
            { $returned = array_merge($returned, get_files($dir."/".$file)); }
            elseif(substr($file,-4,4)=='.php')
            { array_push($returned, $dir."/".$file); }
          }
        }
        closedir($dh);
      }
   }
   return($returned);
}

function analyze_file($file)
{
  $returned=array();
  $handle=fopen($file, "r");
  $read=fread($handle, filesize($file));
  fclose($handle);
  $pos=strpos($read, 'add_event_handler(');
  while($pos!==false)
  {
    $pose=strpos($read, ')', $pos);
    $function=substr($read, $pos, $pose-$pos);
    $nb=substr_count($function, '(');
    while($nb>0)
    {
      $pose=strpos($read, ')', $pose)+1;
      $nb--;
    }
    $function=substr($read, $pos, $pose-$pos);
    
    array_push($returned, $function);
    $pos=strpos($read, 'add_event_handler(', $pose);
  }
  return($returned);
}


$template->set_filenames( array('plugin_admin_content' => dirname(__FILE__).'/PAnalyzer_admin.tpl') );


$files=get_files(PHPWG_ROOT_PATH."plugins");
for($i=0;$i<count($files);$i++)
{
  $result=analyze_file($files[$i]);
  for($j=0;$j<count($result);$j++)
  {
    $template->assign_block_vars('table_row',
      array(
          'FILE' => $files[$i],
          'FUNCTION' => $result[$j]
      )
      
    );
  }
}





 
$template->assign_var_from_handle( 'ADMIN_CONTENT', 'plugin_admin_content');



?>
